import {
  AvatarIcon
} from "./chunk-3R23YVIE.mjs";
import {
  useAvatar
} from "./chunk-OPAVCQIB.mjs";

// src/avatar.tsx
import { forwardRef } from "@nextui-org/system";
import { useMemo } from "react";
import { jsx, jsxs } from "react/jsx-runtime";
var Avatar = forwardRef((props, ref) => {
  const {
    Component,
    src,
    icon = /* @__PURE__ */ jsx(AvatarIcon, {}),
    alt,
    domRef,
    styles,
    slots,
    name,
    showFallback,
    fallback: fallbackComponent,
    getInitials,
    getAvatarProps,
    getImageProps
  } = useAvatar({
    ref,
    ...props
  });
  const fallback = useMemo(() => {
    if (!showFallback && src)
      return null;
    const ariaLabel = alt || name || "avatar";
    if (fallbackComponent) {
      return /* @__PURE__ */ jsx(
        "div",
        {
          "aria-label": ariaLabel,
          className: slots.fallback({ class: styles == null ? void 0 : styles.fallback }),
          role: "img",
          children: fallbackComponent
        }
      );
    }
    return name ? /* @__PURE__ */ jsx("span", { "aria-label": ariaLabel, className: slots.name({ class: styles == null ? void 0 : styles.name }), role: "img", children: getInitials(name) }) : /* @__PURE__ */ jsx("span", { "aria-label": ariaLabel, className: slots.icon({ class: styles == null ? void 0 : styles.icon }), role: "img", children: icon });
  }, [showFallback, src, fallbackComponent, name, styles]);
  return /* @__PURE__ */ jsxs(Component, { ref: domRef, ...getAvatarProps(), children: [
    src && /* @__PURE__ */ jsx("img", { ...getImageProps(), alt }),
    fallback
  ] });
});
Avatar.displayName = "NextUI.Avatar";
var avatar_default = Avatar;

export {
  avatar_default
};
