"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-avatar.ts
var use_avatar_exports = {};
__export(use_avatar_exports, {
  useAvatar: () => useAvatar
});
module.exports = __toCommonJS(use_avatar_exports);
var import_theme = require("@nextui-org/theme");
var import_utils = require("@react-aria/utils");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_shared_utils2 = require("@nextui-org/shared-utils");
var import_focus = require("@react-aria/focus");
var import_react = require("react");
var import_use_image = require("@nextui-org/use-image");

// src/avatar-group-context.ts
var import_shared_utils = require("@nextui-org/shared-utils");
var [AvatarGroupProvider, useAvatarGroupContext] = (0, import_shared_utils.createContext)({
  name: "AvatarGroupContext",
  strict: false
});

// src/use-avatar.ts
function useAvatar(props) {
  var _a, _b, _c, _d, _e;
  const groupContext = useAvatarGroupContext();
  const isInGroup = !!groupContext;
  const {
    as,
    ref,
    src,
    name,
    icon,
    styles,
    fallback,
    alt = name,
    imgRef: imgRefProp,
    color = (_a = groupContext == null ? void 0 : groupContext.color) != null ? _a : "neutral",
    radius = (_b = groupContext == null ? void 0 : groupContext.radius) != null ? _b : "full",
    size = (_c = groupContext == null ? void 0 : groupContext.size) != null ? _c : "md",
    isBordered = (_d = groupContext == null ? void 0 : groupContext.isBordered) != null ? _d : false,
    isDisabled = (_e = groupContext == null ? void 0 : groupContext.isDisabled) != null ? _e : false,
    isFocusable = false,
    getInitials = import_shared_utils2.safeText,
    ignoreFallback = false,
    showFallback: showFallbackProp = false,
    className,
    onError,
    ...otherProps
  } = props;
  const Component = as || "span";
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const imgRef = (0, import_dom_utils.useDOMRef)(imgRefProp);
  const { isFocusVisible, focusProps } = (0, import_focus.useFocusRing)();
  const imageStatus = (0, import_use_image.useImage)({ src, onError, ignoreFallback });
  const isImgLoaded = imageStatus === "loaded";
  const showFallback = (!src || !isImgLoaded) && showFallbackProp;
  const slots = (0, import_react.useMemo)(
    () => {
      var _a2;
      return (0, import_theme.avatar)({
        color,
        radius,
        size,
        isBordered,
        isFocusVisible,
        isDisabled,
        isInGroup,
        isInGridGroup: (_a2 = groupContext == null ? void 0 : groupContext.isGrid) != null ? _a2 : false
      });
    },
    [color, radius, size, isBordered, isFocusVisible, isDisabled, isInGroup, groupContext == null ? void 0 : groupContext.isGrid]
  );
  const buttonStyles = (0, import_react.useMemo)(() => {
    if (as !== "button")
      return "";
    return "appearance-none outline-none border-none cursor-pointer";
  }, [as]);
  const baseStyles = (0, import_shared_utils2.clsx)(styles == null ? void 0 : styles.base, className);
  const canBeFocused = (0, import_react.useMemo)(() => {
    return isFocusable || as === "button";
  }, [isFocusable, as]);
  const getAvatarProps = (0, import_react.useCallback)(
    () => ({
      tabIndex: canBeFocused ? 0 : -1,
      className: slots.base({
        class: (0, import_shared_utils2.clsx)(baseStyles, buttonStyles)
      }),
      ...(0, import_utils.mergeProps)(otherProps, canBeFocused ? focusProps : {})
    }),
    [canBeFocused, slots, baseStyles, buttonStyles, focusProps, otherProps]
  );
  const getImageProps = (0, import_react.useCallback)(
    () => ({
      ref: imgRef,
      src,
      "data-loaded": isImgLoaded,
      className: slots.img({ class: styles == null ? void 0 : styles.img })
    }),
    [slots, isImgLoaded, src, imgRef]
  );
  return {
    Component,
    src,
    alt,
    icon,
    name,
    domRef,
    imgRef,
    slots,
    styles,
    fallback,
    isImgLoaded,
    showFallback,
    ignoreFallback,
    getInitials,
    getAvatarProps,
    getImageProps
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useAvatar
});
